"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.intersection = void 0;
var _reduceLazy_1 = require("./_reduceLazy");
var purry_1 = require("./purry");
function intersection() {
    return (0, purry_1.purry)(_intersection, arguments, intersection.lazy);
}
exports.intersection = intersection;
function _intersection(array, other) {
    var lazy = intersection.lazy(other);
    return (0, _reduceLazy_1._reduceLazy)(array, lazy);
}
(function (intersection) {
    function lazy(other) {
        var set = new Set(other);
        return function (value) {
            return set.has(value)
                ? { done: false, hasNext: true, next: value }
                : { done: false, hasNext: false };
        };
    }
    intersection.lazy = lazy;
})(intersection || (exports.intersection = intersection = {}));
